unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, Unitdefs;

type
  TfmMain = class(TForm)
    Panel1: TPanel;
    btnEnum: TButton;
    CBDevices: TComboBox;
    Memo: TMemo;
    StatusBar: TStatusBar;
    BtnOpen: TButton;
    PageControl2: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    PageControl1: TPageControl;
    TSMaster: TTabSheet;
    lbfreq: TLabel;
    lbchkslv: TLabel;
    BtnWRD: TButton;
    BtnWriteI2C: TButton;
    BtnReadI2C: TButton;
    EditWRI2C: TEdit;
    EditRDI2C: TEdit;
    UpDown1: TUpDown;
    BtnSetSCL: TButton;
    BtnGetSCL: TButton;
    EditSCL: TEdit;
    EditSlv: TEdit;
    btnclear: TButton;
    RBIRQ2: TRadioButton;
    RBIRQ1: TRadioButton;
    RBIRQ0: TRadioButton;
    BtnIRQ: TButton;
    BtnScanI2C: TButton;
    BtnChkSlv: TButton;
    CBfreqUnit: TComboBox;
    TSSLAVE: TTabSheet;
    Label2: TLabel;
    lbSlvAdr: TLabel;
    BtnWRBuf: TButton;
    EditSlvBuf: TEdit;
    CBIntOut: TCheckBox;
    Button1: TButton;
    BtnSetAddr: TButton;
    EditSetSlvAdr: TEdit;
    CBSetAddrGC: TCheckBox;
    Panel2: TPanel;
    BtnSetMode: TButton;
    RBMaster: TRadioButton;
    RBSlave: TRadioButton;
    EditI2CSlvAdr: TEdit;
    CBGCSetMode: TCheckBox;
    RBReadMode: TRadioButton;
    btn_resetsettings: TButton;
    btn_savesettings: TButton;
    btnwrbyte: TButton;
    Label9: TLabel;
    edwrbyte: TEdit;
    Label8: TLabel;
    edwraddr: TEdit;
    edwrword: TEdit;
    Label10: TLabel;
    btnwrword: TButton;
    btnwrdword: TButton;
    Label11: TLabel;
    edwrdword: TEdit;
    edwrblock: TEdit;
    Label12: TLabel;
    btnwrblock: TButton;
    btnrdbyte: TButton;
    Label6: TLabel;
    edrdaddr: TEdit;
    btnrdword: TButton;
    btnrddword: TButton;
    btnrdblock: TButton;
    Label7: TLabel;
    edrdblocklen: TEdit;
    UpDown2: TUpDown;
    Button2: TButton;
    procedure WndProc(var message: TMessage); override;
    procedure BtnOpenClick(Sender: TObject);
    procedure BtnEnumClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnSetModeClick(Sender: TObject);
    procedure BtnWRDClick(Sender: TObject);
    procedure BtnWriteI2CClick(Sender: TObject);
    procedure BtnReadI2CClick(Sender: TObject);
    procedure BtnSetSCLClick(Sender: TObject);
    procedure BtnGetSCLClick(Sender: TObject);
    procedure BtnChkSlvClick(Sender: TObject);
    procedure BtnScanI2CClick(Sender: TObject);
    procedure BtnIRQClick(Sender: TObject);
    procedure BtnWRBufClick(Sender: TObject);
    procedure BtnSetAddrClick(Sender: TObject);
    procedure btnclearClick(Sender: TObject);
    procedure CBDevicesChange(Sender: TObject);
    procedure lbfreqDblClick(Sender: TObject);
    procedure btn_resetsettingsClick(Sender: TObject);
    procedure btn_savesettingsClick(Sender: TObject);
    procedure btnwrbyteClick(Sender: TObject);
    procedure btnrdbyteClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure procGetMode;
  end;

  procedure IRQEvent(DevIndex : Integer); stdcall;
  Procedure SlaveCallBack(const slvdata : Pointer; wSize : Word; DevIndex : Integer); stdcall;

var
  fmMain: TfmMain;
  wPrivateMsg : DWORD;

implementation

{$R *.DFM}

procedure IRQEvent(DevIndex : Integer); stdcall;
begin
  fmMain.memo.lines.add('Interrupt: Device '+IntToStr(DevIndex)+' START');
  sleep(2000);
  fmMain.memo.lines.add('Interrupt: Device '+IntToStr(DevIndex)+' END');
end;

Procedure SlaveCallBack(const slvdata : Pointer; wSize : Word; DevIndex : Integer); stdcall;
var i : word;
    stri : string;
begin
  stri := '';
  for i := 0 to wSize - 1 do
  begin
    Stri := Stri + Format('%.2x ', [Cardinal(PChar(slvdata)[I])]);
  end;
  fmMain.memo.lines.add('SLAVE RX ('+IntToStr(DevIndex)+'):');
  fmMain.memo.lines.add(stri);
end;

procedure TfmMain.FormCreate(Sender: TObject);
begin
  wPrivateMsg := InitUSBIIC(@IRQEvent,@SlaveCallBack,'example_app');
  PageControl1.Pages[1].TabVisible := false;
  CBfreqUnit.ItemIndex := 1;
end;

procedure TfmMain.CBDevicesChange(Sender: TObject);
begin
  if Bool(IsDeviceOpen(CBDevices.ItemIndex)) then
  begin
    BtnOpen.Caption := 'Close';
    procGetMode;
  end else BtnOpen.Caption := 'Open';
end;

procedure TfmMain.BtnOpenClick(Sender: TObject);
var RetVal : DWORD;
begin
  if BtnOpen.Caption = 'Open' then
  begin
    RetVal := OpenDevice(CBDevices.ItemIndex);
    StatusBar.Panels[0].text := 'OPEN DEVICE '+IntToStr(CBDevices.ItemIndex)+' '+GetErrorString(RetVal);
    BtnOpen.Caption := 'Close';
    procGetMode;
  end else
  begin
    RetVal := CloseDevice(CBDevices.ItemIndex);
    StatusBar.Panels[0].text := 'CLOSE DEVICE '+IntToStr(CBDevices.ItemIndex)+' '+GetErrorString(RetVal);
    BtnOpen.Caption := 'Open';
  end;
end;

procedure TfmMain.BtnEnumClick(Sender: TObject);
var DevCnt, i : Integer;
begin
  CBDevices.Clear;
  DevCnt := enumdevices;
  if DevCnt > 0 then
  begin
    for i := 0 to DevCnt - 1 do
      CBDevices.Items.Add(getproductname(i)+' '+getserialnumber(i));
    CBDevices.ItemIndex := 0;  
  end;
  StatusBar.Panels[0].text := IntToStr(DevCnt)+' CLOSE DEVICES FOUND';
end;

procedure TfmMain.procGetMode;
var ucmode, ucslvadr : byte;
    dwErr : DWORD;
begin
  ucMode := 0;  // read settings
  ucSlvAdr := 0;
  dwErr := SetI2CMode(CBDevices.ItemIndex,ucmode,ucslvadr,1000);
  if dwErr = RET_OK then
  begin
    if Bool(ucSlvAdr AND $01) then
      lbSlvAdr.Caption := '0x'+IntToHex(ucSlvAdr AND $FE,2)+' + GC'
    else lbSlvAdr.Caption := '0x'+IntToHex(ucSlvAdr AND $FE,2);
    EditI2CSlvAdr.Text := IntToHex(ucSlvAdr AND $FE,2);
    CBGCSetMode.Checked := Bool(ucSlvAdr AND $01);
    RBMaster.Checked := Bool(ucMode and 1);
    RBSlave.Checked := Bool(ucMode and 2);
    PageControl1.ActivePageIndex := ucMode - 1;
    PageControl1.Pages[0].TabVisible := (ucMode = 1);
    PageControl1.Pages[1].TabVisible := (ucMode = 2);
  end;
  StatusBar.Panels[0].text := 'SET MODE: '+ GetErrorString(dwErr);
end;

procedure TfmMain.BtnSetModeClick(Sender: TObject);
var ucmode, ucslvadr : byte;
    dwErr : DWORD;
begin
  if RBReadMode.Checked then
    ucMode := 0  // read settings
  else if RBMaster.Checked then
    ucMode := 1  // Master mode
  else ucMode := 2; // Slave mode

  ucSlvAdr := StrToIntDef('$'+EditI2CSlvAdr.Text,$FE);
  ucSlvAdr := ucSlvAdr OR Byte(CBGCSetMode.Checked);
  dwErr := SetMode(CBDevices.ItemIndex,ucmode,ucslvadr,1000);
  if dwErr = RET_OK then
  begin
    if Bool(ucSlvAdr AND $01) then
      lbSlvAdr.Caption := '0x'+IntToHex(ucSlvAdr AND $FE,2)+' + GC'
    else lbSlvAdr.Caption := '0x'+IntToHex(ucSlvAdr AND $FE,2);
    EditI2CSlvAdr.Text := IntToHex(ucSlvAdr AND $FE,2);
    CBGCSetMode.Checked := Bool(ucSlvAdr AND $01);
    RBMaster.Checked := Bool(ucMode and 1);
    RBSlave.Checked := Bool(ucMode and 2);
    PageControl1.ActivePageIndex := ucMode - 1;
    PageControl1.Pages[0].TabVisible := (ucMode = 1);
    PageControl1.Pages[1].TabVisible := (ucMode = 2);
  end;
  StatusBar.Panels[0].text := 'SET MODE: '+ GetErrorString(dwErr);
end;

procedure TfmMain.BtnWRDClick(Sender: TObject);
var wStatus, wWRSize, wRDSize, i : WORD;
    si2cdata : String;
    wrdata, rddata : Array of Byte;
    stxt : String;
    dwErr : DWORD;
    ucSlv : Byte;
begin
  ucSlv := StrToIntDef('$'+EditSlv.Text,$40);
  si2cdata := EditWRI2C.Text;
  wWRSize := length(si2cdata) DIV 2;
  setlength(wrdata,wWRSize);
  for i := 0 to wWRSize -1 do
  begin
    wrdata[i] := StrToInt('$'+copy(si2cdata,1,2));
    delete(si2cdata,1,2);
  end;

  wRDSize := StrToIntDef(EditRDI2C.Text,1);
  EditRDI2C.Text := IntToStr(wRDSize);
  setlength(rddata,wRDSize);

  dwErr := WRDI2C(CBDevices.ItemIndex,ucSlv,wrdata[0],wWRSize,rddata[0],wRDSize,wStatus,1000);
  if dwErr = RET_OK then
  begin
    Memo.Lines.Add(IntToStr(wRDSize)+' Byte(s) read:');
    if wRDSize > 0 then
    begin
      stxt := '';
      for i := 0 to wRDSize - 1 do
        stxt := stxt + '['+IntToHex(rddata[i],2)+'] ';
      Memo.Lines.Add(stxt);
    end;
  end;
  StatusBar.Panels[0].text := 'WRITE/READ I2C: '+ GetErrorString(dwErr);
end;

procedure TfmMain.BtnWriteI2CClick(Sender: TObject);
var wStatus, wSize, i : WORD;
    si2cdata : String;
    i2cdata : Array of Byte;
    dwErr   : DWORD;
    ucSlv   : Byte;
begin
  ucSlv := StrToIntDef('$'+EditSlv.Text,$40);
  si2cdata := EditWRI2C.Text;
  wSize := length(si2cdata) DIV 2;
  setlength(i2cdata,wSize);

  for i := 0 to wSize -1 do
  begin
    i2cdata[i] := StrToInt('$'+copy(si2cdata,1,2));
    delete(si2cdata,1,2);
  end;
  dwErr := WriteI2C(CBDevices.ItemIndex,ucSlv,i2cdata[0],wSize,wStatus,1000);
  if dwErr = RET_OK then Memo.Lines.Add(IntToStr(wSize)+' Byte(s) written');
  StatusBar.Panels[0].text := 'WRITE I2C: '+ GetErrorString(dwErr);
end;

procedure TfmMain.BtnReadI2CClick(Sender: TObject);
var wStatus, wSize, i : WORD;
    stxt : String;
    dwErr  : DWORD;
    buf    : Array of Byte;
    ucSlv  : Byte;
begin
  ucSlv := StrToIntDef('$'+EditSlv.Text,$40);
  wSize := StrToIntDef(EditRDI2C.Text,1);
  EditRDI2C.Text := IntToStr(wSize);
  setlength(buf,wSize);
  dwErr := ReadI2C(CBDevices.ItemIndex,ucSlv,buf[0],wSize,wStatus,1000);
  if dwErr = RET_OK then
  begin
    Memo.Lines.Add(IntToStr(wSize)+' Byte(s) read:');
    if wSize > 0 then
    begin
      stxt := '';
      for i := 0 to wSize - 1 do
        stxt := stxt + '['+IntToHex(buf[i],2)+'] ';
      Memo.Lines.Add(stxt);
    end;
  end;
  StatusBar.Panels[0].text := 'READ I2C: '+ GetErrorString(dwErr);
end;

procedure TfmMain.BtnSetSCLClick(Sender: TObject);
var dwfreq : dword;
    dwErr : DWORD;
begin
  dwfreq := StrToIntDef(EditSCL.Text,100);
  if CBfreqUnit.ItemIndex = 1 then dwfreq := dwfreq * 1000;
  dwErr := SetSCL(CBDevices.ItemIndex,dwfreq,1000);
  if dwErr = RET_OK then
  begin
    if dwfreq >= 10000 then
      lbfreq.Caption := IntToStr(Round(dwfreq / 1000))+ ' kHz'
    else if dwfreq >= 1000 then
      lbfreq.Caption := Format('%f kHz',[dwfreq / 1000])
    else lbfreq.Caption := IntToStr(dwfreq)+' Hz';
  end else lbfreq.Caption := '--- Hz';
  StatusBar.Panels[0].text := 'SET SCL: '+ GetErrorString(dwErr);
end;

procedure TfmMain.BtnGetSCLClick(Sender: TObject);
var dwfreq : dword;
    dwErr : DWORD;
begin
  dwErr := GetSCL(CBDevices.ItemIndex,dwfreq,1000);
  if dwErr = RET_OK then
  begin
    if dwfreq >= 10000 then
      lbfreq.Caption := IntToStr(Round(dwfreq / 1000))+ ' kHz'
    else if dwfreq >= 1000 then
      lbfreq.Caption := Format('%f kHz',[dwfreq / 1000])
    else lbfreq.Caption := IntToStr(dwfreq)+' Hz';
  end else lbfreq.Caption := '--- kHz';
  StatusBar.Panels[0].text := 'GET SCL: '+ GetErrorString(dwErr);
end;

procedure TfmMain.BtnChkSlvClick(Sender: TObject);
var ucslvaddr, ucConnected: byte;
    dwErr : DWORD;
begin
  ucslvaddr := StrToIntDef('$'+EditSlv.Text,$FE);
  dwErr := chkslvaddr(CBDevices.ItemIndex,ucslvaddr,ucConnected,1000);
  if dwErr = RET_OK then
  begin
    if ucConnected = 1 then lbchkslv.caption := 'OK'
    else lbchkslv.caption := 'BAD';
    EditSlv.Text := IntToHex(ucslvaddr,2);
  end;
  StatusBar.Panels[0].text := 'CHECK SLAVE ADDR: '+ GetErrorString(dwErr);
end;

procedure TfmMain.BtnScanI2CClick(Sender: TObject);
var dwErr : DWORD;
    buf : Array of Byte;
    ucSize, i : Byte;
    stxt : String;
begin
  Setlength(buf,128);
  dwErr := ScanI2C(CBDevices.ItemIndex,buf[0],ucSize,5000);
  if (dwErr = RET_OK) then
  begin
    if (ucSize > 0) then
    begin
      Memo.Lines.Add(IntToStr(ucSize)+' Device(s) found:');
      stxt := '';
      for i := 0 to ucSize - 1 do
        stxt := stxt + '['+IntToHex(buf[i],2)+'] ';
      Memo.Lines.Add(stxt);
    end else Memo.Lines.Add('NO DEVICES FOUND');
  end;
  StatusBar.Panels[0].text := 'SCAN I2C: '+ GetErrorString(dwErr);
end;

procedure TfmMain.BtnIRQClick(Sender: TObject);
const ResIRQ : array[0..2] of string = ('DISABLE','FALLING EDGE','RISING EDGE');
var dwErr : DWORD;
    ucMode : Byte;
begin
  if RBIRQ0.Checked then ucMode := 0 else //disable interrupt
  if RBIRQ1.Checked then ucMode := 1 else //enable interrupt; falling-edge
  ucMode := 2;                            //enable interrupt; rising-edge

  dwErr := ReSetIRQ(CBDevices.ItemIndex,ucMode,1000);
  if dwErr = RET_OK then
  begin
    case ucMode of
      0 : RBIRQ0.Checked := true;
      1 : RBIRQ1.Checked := true;
      2 : RBIRQ2.Checked := true;
      else RBIRQ0.Checked := true;
    end;
  end;
  StatusBar.Panels[0].text := 'ReSeT IRQ: '+ GetErrorString(dwErr) +' - '+ ResIRQ[ucMode];
end;

procedure TfmMain.BtnWRBufClick(Sender: TObject);
const ResEvent : array[0..1] of string = ('WITHOUT EVENT','WITH EVENT');
var wSize, i : WORD;
    si2cdata : String;
    i2cdata : Array of Byte;
    dwErr   : DWORD;
    ucEvent : Byte;
begin
  ucEvent := Byte(CBIntOut.Checked);
  si2cdata := EditSlvBuf.Text;
  wSize := length(si2cdata) DIV 2;
  setlength(i2cdata,wSize);

  for i := 0 to wSize -1 do
  begin
    i2cdata[i] := StrToInt('$'+copy(si2cdata,1,2));
    delete(si2cdata,1,2);
  end;
  dwErr := writei2cslavebuf(CBDevices.ItemIndex,i2cdata[0],wSize,ucEvent,1000);
  if dwErr = RET_OK then
  begin
    Memo.Lines.Add(IntToStr(wSize)+' Byte(s) written to Slave_Buf');
    Memo.Lines.Add(ResEvent[ucEvent]);
  end;
  StatusBar.Panels[0].text := 'WRITE I2C: '+ GetErrorString(dwErr);
end;

procedure TfmMain.BtnSetAddrClick(Sender: TObject);
var ucslvaddr : byte;
    dwErr : DWORD;
begin
  ucslvaddr := StrToIntDef('$'+EditSetSlvAdr.Text,$FE);
  ucslvaddr := ucslvaddr OR Byte(CBSetAddrGC.Checked);
  dwErr := seti2cslvaddr(CBDevices.ItemIndex,ucslvaddr,1000);
   if dwErr = RET_OK then
   begin
     if Bool(ucslvaddr AND $01) then
      lbSlvAdr.Caption := '0x'+IntToHex(ucslvaddr AND $FE,2)+' + GC'
    else lbSlvAdr.Caption := '0x'+IntToHex(ucslvaddr AND $FE,2);
    EditSetSlvAdr.Text := IntToHex(ucslvaddr AND $FE,2);
    CBSetAddrGC.Checked := Bool(ucslvaddr AND $01);
   end;
  StatusBar.Panels[0].text := 'SET SLAVE ADDR: '+ GetErrorString(dwErr);
end;

procedure TfmMain.btnclearClick(Sender: TObject);
begin
  memo.Lines.Clear;
end;

procedure TfmMain.lbfreqDblClick(Sender: TObject);
begin
  statusbar.Panels[0].text := getproductversion(CBDevices.ItemIndex);
end;

procedure TfmMain.WndProc(var message: TMessage);
begin
  if (Message.Msg = wPrivateMsg) then
  begin
    case (Message.WParam AND $00FF) of
      $E0 : Memo.lines.Add('MSG: DEVICE ARRIVAL');
      $E1 : Memo.lines.Add('MSG: DEVICE REMOVAL');
      $E2 : Memo.lines.Add('MSG: DEVICE CHANGE');
      $09 : Memo.lines.Add('MSG: INTERRUPT - DEVICE ('+IntToStr(Message.LParam)+')');
    end;
  end;
  inherited WndProc(Message);
end;

procedure TfmMain.btn_resetsettingsClick(Sender: TObject);
var dwErr : DWORD;
begin
  dwErr := resetsettings(CBDevices.ItemIndex,2000);
  StatusBar.Panels[0].text := 'RESET SETTINGS: '+ GetErrorString(dwErr);
end;

procedure TfmMain.btn_savesettingsClick(Sender: TObject);
var dwErr : DWORD;
begin
  dwErr := savesettings(CBDevices.ItemIndex,2000);
  StatusBar.Panels[0].text := 'SAVE SETTINGS: '+ GetErrorString(dwErr);
end;

procedure TfmMain.btnwrbyteClick(Sender: TObject);
var tmp_addr  : WORD;
    tmp_byte  : BYTE;
    tmp_word  : WORD;
    tmp_dword : DWORD;
    tmp_data  : array of byte;
    tmp_sdata : string;
    wSize, i  : WORD;
    dwErr     : DWORD;
begin
  tmp_addr := StrToInt('$'+edwraddr.Text);
  case (Sender As TButton).Tag of
  CMD_WRBYTE:
     begin
       tmp_byte := StrToInt('$'+edwrbyte.Text);
       dwErr := memwr8bit(CBDevices.ItemIndex,tmp_addr,tmp_byte,1000);
       statusbar.panels[0].text := 'MEM WR BYTE: '+ GetErrorString(dwErr);
     end;
  CMD_WRWORD:
     begin
       tmp_word := StrToInt('$'+edwrword.Text);
       dwErr := memwr16bit(CBDevices.ItemIndex,tmp_addr,tmp_word,1000);
       statusbar.panels[0].text := 'MEM WR WORD: '+ GetErrorString(dwErr);
     end;
  CMD_WRDWORD:
     begin
       tmp_dword := StrToInt('$'+edwrdword.Text);
       dwErr := memwr32bit(CBDevices.ItemIndex,tmp_addr,tmp_dword,1000);
       statusbar.panels[0].text := 'MEM WR DWORD: '+ GetErrorString(dwErr);
     end;
  CMD_WRBLOCK:
     begin
       tmp_sdata := edwrblock.Text;
       wSize := length(tmp_sdata) DIV 2;
       setlength(tmp_data,wSize);
       for i := 0 to wSize -1 do
       begin
         tmp_data[i] := StrToInt('$'+copy(tmp_sdata,1,2));
         delete(tmp_sdata,1,2);
       end;
       dwErr := memwrblock(CBDevices.ItemIndex,tmp_addr,tmp_data[0],wSize,2000);
       statusbar.panels[0].text := 'MEM WR BLOCK: '+ GetErrorString(dwErr);
     end;
  end;
end;

procedure TfmMain.btnrdbyteClick(Sender: TObject);
var tmp_addr  : WORD;
    wSize, i  : WORD;
    tmp_byte  : Byte;
    tmp_word  : WORD;
    tmp_dword : DWORD;
    tmp_data  : array of Byte;
    dwErr     : DWORD;
    stxt      : String;
begin
  tmp_addr := StrToInt('$'+edrdaddr.Text);
  case (Sender As TButton).Tag of
  CMD_RDBYTE :
    begin
      dwErr := memrd8bit(CBDevices.ItemIndex,tmp_addr,tmp_byte,1000);
      if dwErr = RET_OK then
        Memo.Lines.Add('READ BYTE: 0x'+IntToHex(tmp_byte,2));
      statusbar.panels[0].text := 'MEM RD BYTE: '+ GetErrorString(dwErr);
    end;
  CMD_RDWORD:
    begin
      dwErr := memrd16bit(CBDevices.ItemIndex,tmp_addr,tmp_word,1000);
      Memo.Lines.Add('READ WORD: 0x'+IntToHex(tmp_word,4));
      statusbar.panels[0].text := 'MEM RD WORD: '+ GetErrorString(dwErr);
    end;
  CMD_RDDWORD:
     begin
       dwErr := memrd32bit(CBDevices.ItemIndex,tmp_addr,tmp_dword,1000);
       Memo.Lines.Add('READ DWORD: 0x'+IntToHex(tmp_dword,8));
       statusbar.panels[0].text := 'MEM RD DWORD: '+ GetErrorString(dwErr);
     end;
  CMD_RDBLOCK:
     begin
       wSize := StrToIntDef(edrdblocklen.Text,0);
       setlength(tmp_data,wSize);
       dwErr := memrdblock(CBDevices.ItemIndex,tmp_addr,tmp_data[0],wSize,2000);
       if dwErr = RET_OK then
       begin
         Memo.Lines.Add(IntToStr(wSize)+' Byte(s) read:');
         if wSize > 0 then
         begin
           stxt := '';
           for i := 0 to wSize - 1 do
             stxt := stxt + '['+IntToHex(tmp_data[i],2)+'] ';
           Memo.Lines.Add(stxt);
         end;
       end;
       statusbar.panels[0].text := 'MEM RD BLOCK: '+ GetErrorString(dwErr);
     end;
  end;
end;

end.
